<html>
<head>
<title>OGRE: Ogre::OptimisedUtil Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li class="current"><a href="classes.html"><span>Classes</span></a></li>
    <li><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="tabs">
  <ul>
    <li><a href="classes.html"><span>Alphabetical&nbsp;List</span></a></li>
    <li><a href="annotated.html"><span>Class&nbsp;List</span></a></li>
    <li><a href="hierarchy.html"><span>Class&nbsp;Hierarchy</span></a></li>
    <li><a href="functions.html"><span>Class&nbsp;Members</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="namespaceOgre.html">Ogre</a>::<a class="el" href="classOgre_1_1OptimisedUtil.html">OptimisedUtil</a></div>
<h1>Ogre::OptimisedUtil Class Reference</h1><!-- doxytag: class="Ogre::OptimisedUtil" -->Utility class for provides optimised functions.  
<a href="#_details">More...</a>
<p>
<code>#include &lt;<a class="el" href="OgreOptimisedUtil_8h-source.html">OgreOptimisedUtil.h</a>&gt;</code>
<p>

<p>
<a href="classOgre_1_1OptimisedUtil-members.html">List of all members.</a><table border="0" cellpadding="0" cellspacing="0">
<tr><td></td></tr>
<tr><td colspan="2"><br><h2>Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1OptimisedUtil.html#4f137d0ced0f82abd042d9b4eb99b105">OptimisedUtil</a> (void)</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1OptimisedUtil.html#7d548511ecbd6b39d6d1689ce30db8f2">~OptimisedUtil</a> ()</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1OptimisedUtil.html#69ac35f1a13aa95e2352d0fbbbb204b9">softwareVertexSkinning</a> (const float *srcPosPtr, float *destPosPtr, const float *srcNormPtr, float *destNormPtr, const float *blendWeightPtr, const unsigned char *blendIndexPtr, const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> *const *blendMatrices, size_t srcPosStride, size_t destPosStride, size_t srcNormStride, size_t destNormStride, size_t blendWeightStride, size_t blendIndexStride, size_t numWeightsPerVertex, size_t numVertices)=0</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Performs software vertex skinning.  <a href="#69ac35f1a13aa95e2352d0fbbbb204b9"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1OptimisedUtil.html#c9a4963cc333c8a175f5759a602777ab">softwareVertexMorph</a> (<a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> t, const float *srcPos1, const float *srcPos2, float *dstPos, size_t numVertices)=0</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Performs a software vertex morph, of the kind used for morph animation although it can be used for other purposes.  <a href="#c9a4963cc333c8a175f5759a602777ab"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1OptimisedUtil.html#45b0aaad519e4cace9ca37124f4e646d">concatenateAffineMatrices</a> (const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;baseMatrix, const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> *srcMatrices, <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> *dstMatrices, size_t numMatrices)=0</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Concatenate an affine matrix to an array of affine matrices.  <a href="#45b0aaad519e4cace9ca37124f4e646d"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1OptimisedUtil.html#7fa20b34357e375a489383f0ccb4a15c">calculateFaceNormals</a> (const float *positions, const <a class="el" href="structOgre_1_1EdgeData_1_1Triangle.html">EdgeData::Triangle</a> *triangles, <a class="el" href="classOgre_1_1Vector4.html">Vector4</a> *faceNormals, size_t numTriangles)=0</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Calculate the face normals for the triangles based on position information.  <a href="#7fa20b34357e375a489383f0ccb4a15c"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1OptimisedUtil.html#9270e6273fcf190d039030bd5de1df2f">calculateLightFacing</a> (const <a class="el" href="classOgre_1_1Vector4.html">Vector4</a> &amp;lightPos, const <a class="el" href="classOgre_1_1Vector4.html">Vector4</a> *faceNormals, char *lightFacings, size_t numFaces)=0</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Calculate the light facing state of the triangle's face normals.  <a href="#9270e6273fcf190d039030bd5de1df2f"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1OptimisedUtil.html#5b411cfc1b916483d75df4f4f9c86252">extrudeVertices</a> (const <a class="el" href="classOgre_1_1Vector4.html">Vector4</a> &amp;lightPos, <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> extrudeDist, const float *srcPositions, float *destPositions, size_t numVertices)=0</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Extruding vertices by a fixed distance based on light position.  <a href="#5b411cfc1b916483d75df4f4f9c86252"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Static Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static <a class="el" href="classOgre_1_1OptimisedUtil.html">OptimisedUtil</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1OptimisedUtil.html#ec3039ddfa064375bb4065a4415a8eda">getImplementation</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Gets the implementation of this class.  <a href="#ec3039ddfa064375bb4065a4415a8eda"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Static Protected Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static <a class="el" href="classOgre_1_1OptimisedUtil.html">OptimisedUtil</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1OptimisedUtil.html#bf6a2bcd2039d05d83671e2da3140112">_detectImplementation</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Detect best implementation based on run-time environment.  <a href="#bf6a2bcd2039d05d83671e2da3140112"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Static Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static <a class="el" href="classOgre_1_1OptimisedUtil.html">OptimisedUtil</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1OptimisedUtil.html#f1214c854c521f84997b5ddf77f1a3a5">msImplementation</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Store a pointer to the implementation.  <a href="#f1214c854c521f84997b5ddf77f1a3a5"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Private Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1OptimisedUtil.html#cd57a62f0ea9db4ef52b4d39d83fd019">OptimisedUtil</a> (const <a class="el" href="classOgre_1_1OptimisedUtil.html">OptimisedUtil</a> &amp;rhs)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Privated copy constructor, to prevent misuse.  <a href="#cd57a62f0ea9db4ef52b4d39d83fd019"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1OptimisedUtil.html">OptimisedUtil</a> &amp;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1OptimisedUtil.html#e8975dc2a98c5ae3eb511e8a0336e51e">operator=</a> (const <a class="el" href="classOgre_1_1OptimisedUtil.html">OptimisedUtil</a> &amp;rhs)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Privated operator=, to prevent misuse.  <a href="#e8975dc2a98c5ae3eb511e8a0336e51e"></a><br></td></tr>
</table>
<hr><a name="_details"></a><h2>Detailed Description</h2>
Utility class for provides optimised functions. 
<p>
<dl class="note" compact><dt><b>Note:</b></dt><dd>This class are supposed used by internal engine only. </dd></dl>

<p>Definition at line <a class="el" href="OgreOptimisedUtil_8h-source.html#l00041">41</a> of file <a class="el" href="OgreOptimisedUtil_8h-source.html">OgreOptimisedUtil.h</a>.</p>
<hr><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" name="cd57a62f0ea9db4ef52b4d39d83fd019"></a><!-- doxytag: member="Ogre::OptimisedUtil::OptimisedUtil" ref="cd57a62f0ea9db4ef52b4d39d83fd019" args="(const OptimisedUtil &amp;rhs)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Ogre::OptimisedUtil::OptimisedUtil           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1OptimisedUtil.html">OptimisedUtil</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>rhs</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [private]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Privated copy constructor, to prevent misuse. 
<p>

</div>
</div><p>
<a class="anchor" name="4f137d0ced0f82abd042d9b4eb99b105"></a><!-- doxytag: member="Ogre::OptimisedUtil::OptimisedUtil" ref="4f137d0ced0f82abd042d9b4eb99b105" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Ogre::OptimisedUtil::OptimisedUtil           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreOptimisedUtil_8h-source.html#l00058">58</a> of file <a class="el" href="OgreOptimisedUtil_8h-source.html">OgreOptimisedUtil.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="7d548511ecbd6b39d6d1689ce30db8f2"></a><!-- doxytag: member="Ogre::OptimisedUtil::~OptimisedUtil" ref="7d548511ecbd6b39d6d1689ce30db8f2" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual Ogre::OptimisedUtil::~OptimisedUtil           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreOptimisedUtil_8h-source.html#l00060">60</a> of file <a class="el" href="OgreOptimisedUtil_8h-source.html">OgreOptimisedUtil.h</a>.</p>

</div>
</div><p>
<hr><h2>Member Function Documentation</h2>
<a class="anchor" name="e8975dc2a98c5ae3eb511e8a0336e51e"></a><!-- doxytag: member="Ogre::OptimisedUtil::operator=" ref="e8975dc2a98c5ae3eb511e8a0336e51e" args="(const OptimisedUtil &amp;rhs)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1OptimisedUtil.html">OptimisedUtil</a>&amp; Ogre::OptimisedUtil::operator=           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1OptimisedUtil.html">OptimisedUtil</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>rhs</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [private]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Privated operator=, to prevent misuse. 
<p>

</div>
</div><p>
<a class="anchor" name="bf6a2bcd2039d05d83671e2da3140112"></a><!-- doxytag: member="Ogre::OptimisedUtil::_detectImplementation" ref="bf6a2bcd2039d05d83671e2da3140112" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="classOgre_1_1OptimisedUtil.html">OptimisedUtil</a>* Ogre::OptimisedUtil::_detectImplementation           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [static, protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Detect best implementation based on run-time environment. 
<p>

</div>
</div><p>
<a class="anchor" name="ec3039ddfa064375bb4065a4415a8eda"></a><!-- doxytag: member="Ogre::OptimisedUtil::getImplementation" ref="ec3039ddfa064375bb4065a4415a8eda" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="classOgre_1_1OptimisedUtil.html">OptimisedUtil</a>* Ogre::OptimisedUtil::getImplementation           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Gets the implementation of this class. 
<p>
<dl class="note" compact><dt><b>Note:</b></dt><dd>Don't cache the pointer returned by this function, it'll change due run-time environment detection to pick up the best implementation. </dd></dl>

<p>Definition at line <a class="el" href="OgreOptimisedUtil_8h-source.html#l00067">67</a> of file <a class="el" href="OgreOptimisedUtil_8h-source.html">OgreOptimisedUtil.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="69ac35f1a13aa95e2352d0fbbbb204b9"></a><!-- doxytag: member="Ogre::OptimisedUtil::softwareVertexSkinning" ref="69ac35f1a13aa95e2352d0fbbbb204b9" args="(const float *srcPosPtr, float *destPosPtr, const float *srcNormPtr, float *destNormPtr, const float *blendWeightPtr, const unsigned char *blendIndexPtr, const Matrix4 *const *blendMatrices, size_t srcPosStride, size_t destPosStride, size_t srcNormStride, size_t destNormStride, size_t blendWeightStride, size_t blendIndexStride, size_t numWeightsPerVertex, size_t numVertices)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::OptimisedUtil::softwareVertexSkinning           </td>
          <td>(</td>
          <td class="paramtype">const float *&nbsp;</td>
          <td class="paramname"> <em>srcPosPtr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float *&nbsp;</td>
          <td class="paramname"> <em>destPosPtr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const float *&nbsp;</td>
          <td class="paramname"> <em>srcNormPtr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float *&nbsp;</td>
          <td class="paramname"> <em>destNormPtr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const float *&nbsp;</td>
          <td class="paramname"> <em>blendWeightPtr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const unsigned char *&nbsp;</td>
          <td class="paramname"> <em>blendIndexPtr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> *const *&nbsp;</td>
          <td class="paramname"> <em>blendMatrices</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>srcPosStride</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>destPosStride</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>srcNormStride</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>destNormStride</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>blendWeightStride</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>blendIndexStride</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>numWeightsPerVertex</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>numVertices</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Performs software vertex skinning. 
<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>srcPosPtr</em>&nbsp;</td><td>Pointer to source position buffer. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>destPosPtr</em>&nbsp;</td><td>Pointer to destination position buffer. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>srcNormPtr</em>&nbsp;</td><td>Pointer to source normal buffer, if NULL, means blend position only. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>destNormPtr</em>&nbsp;</td><td>Pointer to destination normal buffer, it's ignored if srcNormPtr is NULL. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>blendWeightPtr</em>&nbsp;</td><td>Pointer to blend weight buffer. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>blendIndexPtr</em>&nbsp;</td><td>Pointer to blend index buffer. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>blendMatrices</em>&nbsp;</td><td>An array of pointer of blend matrix, the matrix must be aligned to SIMD alignment, but not necessary for the array itself. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>srcPosStride</em>&nbsp;</td><td>The stride of source position in bytes. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>destPosStride</em>&nbsp;</td><td>The stride of destination position in bytes. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>srcNormStride</em>&nbsp;</td><td>The stride of source normal in bytes, it's ignored if srcNormPtr is NULL. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>destNormStride</em>&nbsp;</td><td>The stride of destination normal in bytes, it's ignored if srcNormPtr is NULL. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>blendWeightStride</em>&nbsp;</td><td>The stride of blend weight buffer in bytes. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>blendIndexStride</em>&nbsp;</td><td>The stride of blend index buffer in bytes. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>numWeightsPerVertex</em>&nbsp;</td><td>Number of blend weights per-vertex, as well as for blend indices. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>numVertices</em>&nbsp;</td><td>Number of vertices to blend. </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="c9a4963cc333c8a175f5759a602777ab"></a><!-- doxytag: member="Ogre::OptimisedUtil::softwareVertexMorph" ref="c9a4963cc333c8a175f5759a602777ab" args="(Real t, const float *srcPos1, const float *srcPos2, float *dstPos, size_t numVertices)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::OptimisedUtil::softwareVertexMorph           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>t</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const float *&nbsp;</td>
          <td class="paramname"> <em>srcPos1</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const float *&nbsp;</td>
          <td class="paramname"> <em>srcPos2</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float *&nbsp;</td>
          <td class="paramname"> <em>dstPos</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>numVertices</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Performs a software vertex morph, of the kind used for morph animation although it can be used for other purposes. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>This function will linearly interpolate positions between two source buffers, into a third buffer. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>t</em>&nbsp;</td><td>Parametric distance between the start and end positions </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>srcPos1</em>&nbsp;</td><td>Pointer to buffer for the start positions </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>srcPos2</em>&nbsp;</td><td>Pointer to buffer for the end positions </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>dstPos</em>&nbsp;</td><td>Pointer to buffer for the destination positions </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>numVertices</em>&nbsp;</td><td>Number of vertices to morph, which agree with the number in start, end and destination buffer. Bear in mind three floating-point values per vertex </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="45b0aaad519e4cace9ca37124f4e646d"></a><!-- doxytag: member="Ogre::OptimisedUtil::concatenateAffineMatrices" ref="45b0aaad519e4cace9ca37124f4e646d" args="(const Matrix4 &amp;baseMatrix, const Matrix4 *srcMatrices, Matrix4 *dstMatrices, size_t numMatrices)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::OptimisedUtil::concatenateAffineMatrices           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>baseMatrix</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> *&nbsp;</td>
          <td class="paramname"> <em>srcMatrices</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> *&nbsp;</td>
          <td class="paramname"> <em>dstMatrices</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>numMatrices</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Concatenate an affine matrix to an array of affine matrices. 
<p>
<dl class="note" compact><dt><b>Note:</b></dt><dd>An affine matrix is a 4x4 matrix with row 3 equal to (0, 0, 0, 1), e.g. no projective coefficients. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>baseMatrix</em>&nbsp;</td><td>The matrix used as first operand. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>srcMatrices</em>&nbsp;</td><td>An array of matrix used as second operand. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>dstMatrices</em>&nbsp;</td><td>An array of matrix to store matrix concatenate results. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>numMatrices</em>&nbsp;</td><td>Number of matrices in the array. </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="7fa20b34357e375a489383f0ccb4a15c"></a><!-- doxytag: member="Ogre::OptimisedUtil::calculateFaceNormals" ref="7fa20b34357e375a489383f0ccb4a15c" args="(const float *positions, const EdgeData::Triangle *triangles, Vector4 *faceNormals, size_t numTriangles)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::OptimisedUtil::calculateFaceNormals           </td>
          <td>(</td>
          <td class="paramtype">const float *&nbsp;</td>
          <td class="paramname"> <em>positions</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="structOgre_1_1EdgeData_1_1Triangle.html">EdgeData::Triangle</a> *&nbsp;</td>
          <td class="paramname"> <em>triangles</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Vector4.html">Vector4</a> *&nbsp;</td>
          <td class="paramname"> <em>faceNormals</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>numTriangles</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Calculate the face normals for the triangles based on position information. 
<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>positions</em>&nbsp;</td><td>Pointer to position information, which packed in (x, y, z) format, indexing by vertex index in the triangle. No alignment requests. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>triangles</em>&nbsp;</td><td>The triangles need to calculate face normal, the vertex positions is indexed by vertex index to position information. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>faceNormals</em>&nbsp;</td><td>The array of <a class="el" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a> used to store triangles face normal, Must be aligned to SIMD alignment. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>numTriangles</em>&nbsp;</td><td>Number of triangles to calculate face normal. </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="9270e6273fcf190d039030bd5de1df2f"></a><!-- doxytag: member="Ogre::OptimisedUtil::calculateLightFacing" ref="9270e6273fcf190d039030bd5de1df2f" args="(const Vector4 &amp;lightPos, const Vector4 *faceNormals, char *lightFacings, size_t numFaces)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::OptimisedUtil::calculateLightFacing           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector4.html">Vector4</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>lightPos</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector4.html">Vector4</a> *&nbsp;</td>
          <td class="paramname"> <em>faceNormals</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">char *&nbsp;</td>
          <td class="paramname"> <em>lightFacings</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>numFaces</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Calculate the light facing state of the triangle's face normals. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>This is normally the first stage of calculating a silhouette, ie establishing which tris are facing the light and which are facing away. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>lightPos</em>&nbsp;</td><td>4D position of the light in object space, note that for directional lights (which have no position), the w component is 0 and the x/y/z position are the direction. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>faceNormals</em>&nbsp;</td><td>An array of face normals for the triangles, the face normal are unit vector othogonal to the triangles, plus distance from origin. This array must be aligned to SIMD alignment. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>lightFacings</em>&nbsp;</td><td>An array of flags for store light facing state results, the result flag is true if corresponding face normal facing the light, false otherwise. This array no alignment requires. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>numFaces</em>&nbsp;</td><td>Number of face normals to calculate. </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="5b411cfc1b916483d75df4f4f9c86252"></a><!-- doxytag: member="Ogre::OptimisedUtil::extrudeVertices" ref="5b411cfc1b916483d75df4f4f9c86252" args="(const Vector4 &amp;lightPos, Real extrudeDist, const float *srcPositions, float *destPositions, size_t numVertices)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::OptimisedUtil::extrudeVertices           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector4.html">Vector4</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>lightPos</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>extrudeDist</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const float *&nbsp;</td>
          <td class="paramname"> <em>srcPositions</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float *&nbsp;</td>
          <td class="paramname"> <em>destPositions</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>numVertices</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Extruding vertices by a fixed distance based on light position. 
<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>lightPos</em>&nbsp;</td><td>4D light position, when w=0.0f this represents a directional light, otherwise, w must be equal to 1.0f, which represents a point light. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>extrudeDist</em>&nbsp;</td><td>The distance to extrude. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>srcPositions</em>&nbsp;</td><td>Pointer to source vertex's position buffer, which the position is a 3D vector packed in xyz format. No SIMD alignment requirement but loss performance for unaligned data. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>destPositions</em>&nbsp;</td><td>Pointer to destination vertex's position buffer, which the position is a 3D vector packed in xyz format. No SIMD alignment requirement but loss performance for unaligned data. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>numVertices</em>&nbsp;</td><td>Number of vertices need to extruding, which agree with source and destination buffers. </td></tr>
  </table>
</dl>

</div>
</div><p>
<hr><h2>Member Data Documentation</h2>
<a class="anchor" name="f1214c854c521f84997b5ddf77f1a3a5"></a><!-- doxytag: member="Ogre::OptimisedUtil::msImplementation" ref="f1214c854c521f84997b5ddf77f1a3a5" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1OptimisedUtil.html">OptimisedUtil</a>* <a class="el" href="classOgre_1_1OptimisedUtil.html#f1214c854c521f84997b5ddf77f1a3a5">Ogre::OptimisedUtil::msImplementation</a><code> [static, protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Store a pointer to the implementation. 
<p>

<p>Definition at line <a class="el" href="OgreOptimisedUtil_8h-source.html#l00051">51</a> of file <a class="el" href="OgreOptimisedUtil_8h-source.html">OgreOptimisedUtil.h</a>.</p>

</div>
</div><p>
<hr>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreOptimisedUtil_8h-source.html">OgreOptimisedUtil.h</a></ul>
<hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:51:00 2008
</p>
</body>
</html>
